<template>
  <div class="game-screen">
    <div v-if="!getName">
      <h1>Vui long nhap ten cua ban o trang</h1>
      <router-link to="/">Home</router-link>
    </div>
    <div class="about container" v-else>
      <h1>Xin chào bạn {{ getName }}</h1>
      <h1>Số tiền đã đạt được: {{ money }}</h1>
      <div class="answers row" v-if="loading === true">
        <img src="../../public/1495.gif" class="center" alt="" />
      </div>
      <Question
        v-else
        :chose="isChose"
        @get-right-answer="getRight"
        :questions="questions[i]"
      />
    </div>
  </div>
</template>

<script>
import Question from "./Question";
import { mapState, mapActions } from "vuex";
// import {QuestionMixin} from '../mixin/QuestionMixin.js'

export default {
  name: "Game",
  components: {
    Question,
  },
  data() {
    return {
      isChose: "",
    };
  },
  computed: {
    ...mapState({
      questions: (state) => state.Question.questions,
      loading: (state) => state.Question.loading,
      i: (state) => state.Question.i,
      money: (state) => state.Question.money,
      isClicked: (state) => state.Question.isClicked,
    }),
    getName() {
      return localStorage.getItem("name");
    },
  },
  methods: {
    ...mapActions({
      fetchData: "SET_QUESTIONS",
    }),
    getRight(rightAnswer) {
      this.isChose = rightAnswer;
      setTimeout(() => {
        if (
          confirm("Bạn có chắc chọn câu trả lời " + rightAnswer + " không?")
        ) {
          if (this.questions[this.i].answer_right === rightAnswer) {
            alert("Đây là câu trả lòi chính xác");
            this.isObjectLenght();

            this.$store.commit("SET_MONEY", 1000);

            this.$store.commit("SET_I", 1);
          } else {
            alert("Bạn đã trả lời sai rồi");
            if (confirm("Bạn có muốn chơi lại không")) {
              this.fetchData();
              localStorage.removeItem("point");
              this.$store.commit("SET_BEGIN_I", 0);
              this.$store.commit("SET_MONEY_BEGIN", 0);
            } else {
              localStorage.setItem("point", this.money);
              localStorage.setItem("complete", true);

              this.$router.push({
                name: "Final",
                params: {
                  name: this.$route.params.name ?? "",
                  point: this.money,
                },
              });
            }
          }
        } else {
          this.isChose = '';
        }
      }, 300);
    },
    // getQuestions() { using mixin to get data close in here
    //   this.loading = true;
    //   axios.get('http://game-vue.herokuapp.com/api/questions')
    //   .then((response) => {
    //     this.questions = response.data
    //   }).catch((error) => {
    //     console.log(error);
    //   }).finally(() => (this.loading = false))
    // },
    isObjectLenght() {
      if (this.i === this.questions.length) {
        localStorage.setItem("point", this.money);

        localStorage.setItem("complete", true);
        this.$route.push({
          name: "Final",
          params: { name: this.$route.params.name ?? "", point: this.money },
        });
      }
    },
  },
  beforeCreate() {
    this.$store.commit("SET_BEGIN_I", 0);
    this.$store.commit("SET_MONEY_BEGIN", 0);
    localStorage.setItem("complete", false);
    localStorage.removeItem("point");
  },
  created() {
    //close using mixin for get data
    this.fetchData();
  },
};
</script>

<style scoped>
.center {
  display: block;
  margin-left: auto;
  margin-right: auto;
}
</style>
